import './index.sass';
import { ComponentProps, ReactNode, Ref } from 'react';
import { Mix } from './Item';
export interface DOMProps extends Omit<ComponentProps<'div'>, 'children'> {
    domRef?: Ref<HTMLDivElement>;
}
export interface Props<WithItem extends boolean = false> extends DOMProps {
    children: WithItem extends true ? Mix : ReactNode | undefined;
    direction?: 'horizontal' | 'vertical';
    positioning?: 'stretch' | 'center' | 'offset';
    strictPositioning?: WithItem extends true ? boolean : never;
    startOffset?: number;
    endOffset?: number;
}
export default function Container<WithItem extends boolean>({ domRef, children, className, style, direction, positioning, strictPositioning, startOffset, endOffset, ...domProps }: Props<WithItem>): JSX.Element;
