var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import "./index.css";
import React from 'react';
import cn from '../cn';
import Item from './Item';
export default function Container(_a) {
  var {
    domRef,
    children,
    className,
    style = {},
    direction,
    positioning = 'stretch',
    strictPositioning,
    startOffset,
    endOffset
  } = _a,
      domProps = __rest(_a, ["domRef", "children", "className", "style", "direction", "positioning", "strictPositioning", "startOffset", "endOffset"]);

  const availableSpace = 1 - (startOffset !== null && startOffset !== void 0 ? startOffset : 0) - (endOffset !== null && endOffset !== void 0 ? endOffset : 0);
  const cnBase = cn('Container');
  return /*#__PURE__*/React.createElement("div", Object.assign({
    ref: domRef,
    className: cnBase({
      direction,
      positioning,
      strictPositioning
    }, [className]),
    style: Object.assign(Object.assign({}, style), {
      [`--${cnBase()}_startOffset`]: startOffset,
      [`--${cnBase()}_endOffset`]: endOffset
    })
  }, domProps), typeof children === 'function' ? /*#__PURE__*/React.createElement(Item, {
    maxWidth: strictPositioning && direction === 'horizontal' ? availableSpace : undefined,
    maxHeight: strictPositioning && direction === 'vertical' ? availableSpace : undefined
  }, children) : children);
}