import './Popup.sass';
import { ReactNode } from 'react';
import { Props as TargetProps, Position } from '../Popup';
export interface Props {
    children: Render<{
        toggle: ReactNode;
        content: ReactNode;
    }>;
    calculatePosition: CalculatePosition;
    renderMode: TargetProps['renderMode'];
}
export declare type Render<Format = ReactNode> = (active: boolean, activate: Activate) => Format;
export declare type CalculatePosition = (relativeToggle: DOMRect, toggle: DOMRect, space: DOMRect) => Position;
export declare type Activate = (active?: unknown) => void;
export default function LayersPopup({ children, calculatePosition, renderMode }: Props): JSX.Element;
