import "./Popup.css";
import React, { useState, useRef, useMemo, useCallback } from 'react';
import { createPortal } from 'react-dom';
import cn from '../cn';
import Container from '../Container';
import Popup from '../Popup';
import Control, { useLayersControlContext } from './Control';
export default function LayersPopup({
  children,
  calculatePosition,
  renderMode
}) {
  const {
    frontLayer,
    setCurrentComponent,
    nesting
  } = useLayersControlContext();
  const toggleElement = useRef(null);
  const [active, setActive] = useState(false);
  const activate = useCallback(active => setActive(wasActive => {
    if (typeof active === 'function') active = active(wasActive);
    const makeActive = typeof active === 'boolean' ? active : !wasActive;
    if (wasActive !== makeActive) setCurrentComponent(() => setActive(false));
    setActive(makeActive);
    return makeActive;
  }), [setCurrentComponent]);
  const calculateRelativePosition = useCallback(space => {
    const toggleSize = toggleElement.current.getBoundingClientRect();
    return calculatePosition(new DOMRect((toggleSize.x - space.x) / space.width, (toggleSize.y - space.y) / space.height, toggleSize.width / space.width, toggleSize.height / space.height), toggleSize, space);
  }, [calculatePosition]);
  const {
    toggle,
    content
  } = useMemo(() => children(active, activate), [children, active, activate]);
  const cnBase = cn('Layers', 'Popup');
  return /*#__PURE__*/React.createElement(Control, null, /*#__PURE__*/React.createElement(Container, {
    domRef: toggleElement
  }, toggle), /*#__PURE__*/createPortal( /*#__PURE__*/React.createElement("article", {
    className: cnBase(),
    style: {
      [`--${cnBase()}_nesting`]: nesting
    }
  }, /*#__PURE__*/React.createElement(Popup, {
    active: active,
    calculatePosition: calculateRelativePosition,
    renderMode: renderMode
  }, content)), frontLayer));
}