import './index.sass';
import { ReactNode } from 'react';
import { Props as ContainerProps } from '../Container';
export interface Props {
    children?: ReactNode;
    active?: boolean;
    calculatePosition: CalculatePosition;
    renderMode?: 'always' | 'whenActive' | 'afterFirstActivate';
}
export declare type CalculatePosition = (space: DOMRect) => Position;
export interface Position {
    top?: number;
    right?: number;
    bottom?: number;
    left?: number;
    verticalPosition?: PositionType;
    horizontalPosition?: PositionType;
}
declare type PositionType = ContainerProps<true>['positioning'] | `${Required<ContainerProps<true>>['positioning']}Strict`;
export default function Popup({ children, active, calculatePosition, renderMode }: Props): JSX.Element | null;
export {};
